Index: apps/app_curl.c
===================================================================
--- apps/app_curl.c	(revision 42)
+++ apps/app_curl.c	(working copy)
@@ -55,6 +55,8 @@
 "  postdata - This information will be treated as POST data.\n"
 "This application will set the following variable:\n"
 "  CURL - This variable will contain the resulting page.\n"
+"The following variables will be read:\n"
+"  CURL_PROXY - Same as the -x/--proxy option to the curl program.\n"
 "This application has been deprecated in favor of the CURL function.\n";
 
 STANDARD_LOCAL_USER;
@@ -90,9 +92,10 @@
 	return realsize;
 }
 
-static int curl_internal(struct MemoryStruct *chunk, char *url, char *post)
+static int curl_internal(struct ast_channel *chan, struct MemoryStruct *chunk, char *url, char *post)
 {
 	CURL *curl;
+	char *curl_proxy;
 
 	curl_global_init(CURL_GLOBAL_ALL);
 	curl = curl_easy_init();
@@ -106,6 +109,9 @@
 	curl_easy_setopt(curl, CURLOPT_WRITEDATA, (void *)chunk);
 	curl_easy_setopt(curl, CURLOPT_USERAGENT, "asterisk-libcurl-agent/1.0");
 
+	if((curl_proxy = pbx_builtin_getvar_helper(chan, "CURL_PROXY")))
+		curl_easy_setopt(curl, CURLOPT_PROXY, curl_proxy);
+
 	if (post) {
 		curl_easy_setopt(curl, CURLOPT_POST, 1);
 		curl_easy_setopt(curl, CURLOPT_POSTFIELDS, post);
@@ -145,7 +151,7 @@
 		return -1;
 	}
 
-	if (! curl_internal(&chunk, url, post_data)) {
+	if (! curl_internal(chan, &chunk, url, post_data)) {
 		if (chunk.memory) {
 			chunk.memory[chunk.size] = '\0';
 			if (chunk.memory[chunk.size - 1] == 10)
@@ -189,7 +195,7 @@
 	url = strsep(&info, "|");
 	post_data = info;
 	
-	if (! curl_internal(&chunk, url, post_data)) {
+	if (! curl_internal(chan, &chunk, url, post_data)) {
 		if (chunk.memory) {
 			chunk.memory[chunk.size] = '\0';
 			if (chunk.memory[chunk.size - 1] == 10)
@@ -212,7 +218,9 @@
 	.syntax = "CURL(url[|post-data])",
 	.desc =
 	"  url       - URL to retrieve\n"
-	"  post-data - Optional data to send as a POST (GET is default action)\n",
+	"  post-data - Optional data to send as a POST (GET is default action)\n"
+	"The following variables will be read:\n"
+	"  CURL_PROXY - Same as the -x/--proxy option to the curl program.\n",
 	.read = acf_curl_exec,
 };
 
